struct PathNode (
	isCross, width, left, right
)

pathAttrib = attributes pathData
attribID:#(0x52910dee, 0x199321d2)
(
	parameters main rollout:params (
		isCarPath type:#boolean ui:chk_car default:false
		nodeData type:#inttab tabSizeVariable:true
		isCross type:#boolean ui:chk_cross
		width type:#integer ui:spn_width
		left type:#integer ui:spn_left
		right type:#integer ui:spn_right
		-- isCross, width, left, right
	)
	 
	rollout params "Gta Path" (
		checkbox chk_car "Car Path"
		button btn_get "Get"
		checkbox chk_cross "is cross"
		spinner spn_width "width" type:#integer range:[0,100,10]
		spinner spn_left "left lanes" type:#integer range:[0,100,1]
		spinner spn_right "right lanes" type:#integer range:[0,100,1]
		button btn_set "Set"
		on btn_get pressed do (
			shp = $
			n = getFirstSelKnot shp
			if n != undefined do (
				pn = getPathNodeData shp n[1] n[2]
				isCross = pn.isCross != 0
				width = pn.width
				left = pn.left
				right = pn.right
			)
		)
		on btn_set pressed do (
			shp = $
			n = getFirstSelKnot shp
			if n != undefined do (
				pn = PathNode isCross:(if isCross then 1 else 0) width:width left:left right:right
				setPathNodeData shp n[1] n[2] pn
			)
		)
	)
)

-- getsplineselection $
-- getsegselection $ 1
-- getknotselection $ 1


fn getPathNodeData shp i j = (
	i = (i*12 + j)*4
	pn = PathNode()
	pn.isCross = shp.nodeData[i+0]
	if pn.isCross == undefined do
		pn.isCross = 0
	pn.width = shp.nodeData[i+1]
	if pn.width == undefined do
		pn.width = 10
	pn.left = shp.nodeData[i+2]
	if pn.left == undefined do
		pn.left = 1
	pn.right = shp.nodeData[i+3]
	if pn.right == undefined do
		pn.right = 1
	pn
)

fn setPathNodeData shp i j pn = (
	i = (i*12 + j)*4
	shp.nodeData[i+0] = pn.isCross
	shp.nodeData[i+1] = pn.width
	shp.nodeData[i+2] = pn.left
	shp.nodeData[i+3] = pn.right
)

fn getFirstSelKnot shp = (
	for i = 1 to (numSplines shp) do(
		sel = (getknotselection shp i)
		if sel.count != 0 do
			return #(i, sel[1])
	)
	return undefined
)

getFirstSelKnot $
-- PathNode isCross:0 width:10 left:1 right:1

fn dumpVertices shp = (
	if (classof shp) != SplineShape do
		convertToSplineShape shp
	print (numSplines shp)
	for i = 1 to numSplines shp do
		for j = 1 to (numKnots shp i) - 1 do (
			print (getKnotPoint shp i j)
			print (getPathNodeData shp i j)
		)
)

fn getVertIdx verts v = (
	i = finditem verts v
	if i > 0 do return i
	append verts v
	verts.count
)

fn dumppath shp = (
	verts = #()
	seen = #{}
    internal = #{}
	used = #{}
	next = #()
	for i = 1 to shp.numSplines do
		for j = 1 to (numKnots shp i) - 1 do (
			i1 = getVertIdx verts (getKnotPoint shp i j)
			i2 = getVertIdx verts (getKnotPoint shp i (j + 1))
			if seen[i1] do internal[i1] = true
			if seen[i2] do internal[i2] = true
			seen[i1] = true
			seen[i2] = true
			if used[i1] and used[i2] do (
				print "error: path loop"
				return 0
			)
			if used[i1] then (
				next[i2] = i1
				used[i2] = true
			) else (
				next[i1] = i2
				used[i1] = true
			)
		)
	for i = 1 to next.count do (
		s = "	"
		s += ((if internal[i] then 2 else 1) as string) + ", "
		s += ((if next[i] != undefined then next[i]-1 else -1) as string) + ", "
		s += "0, "
		s += (((verts[i].x*16) as integer) as string) + ", "
		s += (((verts[i].y*16) as integer) as string) + ", "
		s += (((verts[i].z*16) as integer) as string) + ", "
		s += "160, "
		s += "1, "
		s += "1"
		print s
	)
	for i = next.count+1 to 12 do
		print "	0, -1, 0, 0, 0, 0, 0, 1, 1"
)

fn makePathObject obj = (
	if (custAttributes.get obj pathAttrib) != undefined do
		return obj
	obj.name = uniquename "PathSegment"
	custAttributes.add obj pathAttrib
)

makePathObject $
dumpVertices $